//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "E7_DInput.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TE7_DInput *)
{
    new TE7_DInput(NULL);
}
//---------------------------------------------------------------------------
TE7_DInput *AE7_DInput;
//---------------------------------------------------------------------------
void Timer2Timer(HWND H, UINT Msg, UINT Event, DWORD Time)
{
  if (AE7_DInput->Active) AE7_DInput->UpdateInputState();
}
//---------------------------------------------------------------------------
__fastcall TE7_DInput::TE7_DInput(TComponent* Owner)
    : TComponent(Owner)
{
  FHandle = ((TWinControl *)(Owner))->Handle;
  FDirectInput = NULL;
  FKeyboard = NULL;
  FActive = false;
}
//---------------------------------------------------------------------------
__fastcall TE7_DInput::~TE7_DInput()
{
  EndInput();
}
//-----------------------------------------------------------------------------
AnsiString __fastcall TE7_DInput::Bind(AnsiString KeyCode, AnsiString KeyCommand)
{
  AnsiString Msg;
  int KeyNum = GetKeyCode(KeyCode);

  if ((KeyNum < 1) || (KeyNum > 255)) return "Incorrect Number";

  if (KeyCommand.Length() == 0) {
    if (strcmp(FKeyCom[KeyNum], " ") == 0)
     Msg = GetKeyName(KeyNum) + " Not bound";
    else Msg = GetKeyName(KeyNum) + " " + FKeyCom[KeyNum];
  }
  else {
    strcpy(FKeyCom[KeyNum], KeyCommand.c_str());
    Msg = GetKeyName(KeyNum) + " Bound";
  }

  return Msg;
}
//-----------------------------------------------------------------------------
void __fastcall TE7_DInput::EndInput()
{
  if(FKeyboard) {
    FKeyboard->Unacquire();
    FKeyboard->Release();
    FKeyboard = NULL;
  }

  if(FDirectInput) {
    FDirectInput->Release();
    FDirectInput = NULL;
  }
  FActive = false;
}
//-----------------------------------------------------------------------------
int __fastcall TE7_DInput::GetKeyCode(AnsiString KeyName)
{
  int Code;

  KeyName = KeyName.UpperCase();

  if (KeyName == "ESCAPE") Code = 0x01;
  else if (KeyName == "1") Code = 0x02;
  else if (KeyName == "2") Code = 0x03;
  else if (KeyName == "3") Code = 0x04;
  else if (KeyName == "4") Code = 0x05;
  else if (KeyName == "5") Code = 0x06;
  else if (KeyName == "6") Code = 0x07;
  else if (KeyName == "7") Code = 0x08;
  else if (KeyName == "8") Code = 0x09;
  else if (KeyName == "9") Code = 0x0A;
  else if (KeyName == "0") Code = 0x0B;
  else if (KeyName == "-") Code = 0x0C;
  else if (KeyName == "=") Code = 0x0D;
  else if (KeyName == "BACKSPACE") Code = 0x0E;
  else if (KeyName == "TAB") Code = 0x0F;
  else if (KeyName == "Q") Code = 0x10;
  else if (KeyName == "W") Code = 0x11;
  else if (KeyName == "E") Code = 0x12;
  else if (KeyName == "R") Code = 0x13;
  else if (KeyName == "T") Code = 0x14;
  else if (KeyName == "Y") Code = 0x15;
  else if (KeyName == "U") Code = 0x16;
  else if (KeyName == "I") Code = 0x17;
  else if (KeyName == "O") Code = 0x18;
  else if (KeyName == "P") Code = 0x19;
  else if (KeyName == "[") Code = 0x1A;
  else if (KeyName == "]") Code = 0x1B;
  else if (KeyName == "ENTER") Code = 0x1C;
  else if (KeyName == "LCONTROL") Code = 0x1D;
  else if (KeyName == "A") Code = 0x1E;
  else if (KeyName == "S") Code = 0x1F;
  else if (KeyName == "D") Code = 0x20;
  else if (KeyName == "F") Code = 0x21;
  else if (KeyName == "G") Code = 0x22;
  else if (KeyName == "H") Code = 0x23;
  else if (KeyName == "J") Code = 0x24;
  else if (KeyName == "K") Code = 0x25;
  else if (KeyName == "L") Code = 0x26;
  else if (KeyName == ";") Code = 0x27;
  else if (KeyName == "'") Code = 0x28;
  else if (KeyName == "`") Code = 0x29;
  else if (KeyName == "LSHIFT") Code = 0x2A;
  else if (KeyName == "#") Code = 0x2B;
  else if (KeyName == "Z") Code = 0x2C;
  else if (KeyName == "X") Code = 0x2D;
  else if (KeyName == "C") Code = 0x2E;
  else if (KeyName == "V") Code = 0x2F;
  else if (KeyName == "B") Code = 0x30;
  else if (KeyName == "N") Code = 0x31;
  else if (KeyName == "M") Code = 0x32;
  else if (KeyName == ",") Code = 0x33;
  else if (KeyName == ".") Code = 0x34;
  else if (KeyName == "/") Code = 0x35;
  else if (KeyName == "RSHIFT") Code = 0x36;
  else if (KeyName == "LALT") Code = 0x38;
  else if (KeyName == "SPACE") Code = 0x39;
  else if (KeyName == "CAPSLOCK") Code = 0x3A;
  else if (KeyName == "F1") Code = 0x3B;
  else if (KeyName == "F2") Code = 0x3C;
  else if (KeyName == "F3") Code = 0x3D;
  else if (KeyName == "F4") Code = 0x3E;
  else if (KeyName == "F5") Code = 0x3F;
  else if (KeyName == "F6") Code = 0x40;
  else if (KeyName == "F7") Code = 0x41;
  else if (KeyName == "F8") Code = 0x42;
  else if (KeyName == "F9") Code = 0x43;
  else if (KeyName == "F10") Code = 0x44;
  else if (KeyName == "NUMPAD7") Code = 0x47;
  else if (KeyName == "NUMPAD8") Code = 0x48;
  else if (KeyName == "NUMPAD9") Code = 0x49;
  else if (KeyName == "NUMPAD4") Code = 0x4B;
  else if (KeyName == "NUMPAD5") Code = 0x4C;
  else if (KeyName == "NUMPAD6") Code = 0x4D;
  else if (KeyName == "NUMPAD1") Code = 0x4F;
  else if (KeyName == "NUMPAD2") Code = 0x50;
  else if (KeyName == "NUMPAD3") Code = 0x51;
  else if (KeyName == "NUMPAD0") Code = 0x52;
  else if (KeyName == "F11") Code = 0x57;
  else if (KeyName == "F12") Code = 0x58;
  else if (KeyName == "RCONTROL") Code = 0x9D;
  else if (KeyName == "RALT") Code = 0xB8;
  else if (KeyName == "HOME") Code = 0xC7;
  else if (KeyName == "UP") Code = 0xC8;
  else if (KeyName == "PAGEUP") Code = 0xC9;
  else if (KeyName == "LEFT") Code = 0xCB;
  else if (KeyName == "RIGHT") Code = 0xCD;
  else if (KeyName == "END") Code = 0xCF;
  else if (KeyName == "DOWN") Code = 0xD0;
  else if (KeyName == "PAGEDOWN") Code = 0xD1;
  else if (KeyName == "INSERT") Code = 0xD2;
  else if (KeyName == "DELETE") Code = 0xD3;

  return Code;
}
//-----------------------------------------------------------------------------
AnsiString __fastcall TE7_DInput::GetCommand(const int KeyNum)
{
  AnsiString Comm;
  Comm = FKeyCom[KeyNum];
  return Comm;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TE7_DInput::GetKeyName(int Code)
{
  AnsiString KeyName = "";
  switch(Code) {
    case 0x01:  KeyName = "ESCAPE"; break;
    case 0x02:  KeyName = "1"; break;
    case 0x03:  KeyName = "2"; break;
    case 0x04:  KeyName = "3"; break;
    case 0x05:  KeyName = "4"; break;
    case 0x06:  KeyName = "5"; break;
    case 0x07:  KeyName = "6"; break;
    case 0x08:  KeyName = "7"; break;
    case 0x09:  KeyName = "8"; break;
    case 0x0A:  KeyName = "9"; break;
    case 0x0B:  KeyName = "0"; break;
    case 0x0C:  KeyName = "-"; break;
    case 0x0D:  KeyName = "="; break;
    case 0x0E:  KeyName = "BACKSPACE"; break;
    case 0x0F:  KeyName = "TAB"; break;
    case 0x10:  KeyName = "Q"; break;
    case 0x11:  KeyName = "W"; break;
    case 0x12:  KeyName = "E"; break;
    case 0x13:  KeyName = "R"; break;
    case 0x14:  KeyName = "T"; break;
    case 0x15:  KeyName = "Y"; break;
    case 0x16:  KeyName = "U"; break;
    case 0x17:  KeyName = "I"; break;
    case 0x18:  KeyName = "O"; break;
    case 0x19:  KeyName = "P"; break;
    case 0x1A:  KeyName = "["; break;
    case 0x1B:  KeyName = "]"; break;
    case 0x1C:  KeyName = "ENTER"; break;
    case 0x1D:  KeyName = "LCONTROL"; break;
    case 0x1E:  KeyName = "A"; break;
    case 0x1F:  KeyName = "S"; break;
    case 0x20:  KeyName = "D"; break;
    case 0x21:  KeyName = "F"; break;
    case 0x22:  KeyName = "G"; break;
    case 0x23:  KeyName = "H"; break;
    case 0x24:  KeyName = "J"; break;
    case 0x25:  KeyName = "K"; break;
    case 0x26:  KeyName = "L"; break;
    case 0x27:  KeyName = ";"; break;
    case 0x28:  KeyName = "'"; break;
    case 0x29:  KeyName = "`"; break;
    case 0x2A:  KeyName = "LSHIFT"; break;
    case 0x2B:  KeyName = "#"; break;
    case 0x2C:  KeyName = "Z"; break;
    case 0x2D:  KeyName = "X"; break;
    case 0x2E:  KeyName = "C"; break;
    case 0x2F:  KeyName = "V"; break;
    case 0x30:  KeyName = "B"; break;
    case 0x31:  KeyName = "N"; break;
    case 0x32:  KeyName = "M"; break;
    case 0x33:  KeyName = ","; break;
    case 0x34:  KeyName = "."; break;
    case 0x35:  KeyName = "/"; break;
    case 0x36:  KeyName = "RSHIFT"; break;
    case 0x38:  KeyName = "LALT"; break;
    case 0x39:  KeyName = "SPACE"; break;
    case 0x3A:  KeyName = "CAPSLOCK"; break;
    case 0x3B:  KeyName = "F1"; break;
    case 0x3C:  KeyName = "F2"; break;
    case 0x3D:  KeyName = "F3"; break;
    case 0x3E:  KeyName = "F4"; break;
    case 0x3F:  KeyName = "F5"; break;
    case 0x40:  KeyName = "F6"; break;
    case 0x41:  KeyName = "F7"; break;
    case 0x42:  KeyName = "F8"; break;
    case 0x43:  KeyName = "F9"; break;
    case 0x44:  KeyName = "F10"; break;
    case 0x47:  KeyName = "NUMPAD7"; break;
    case 0x48:  KeyName = "NUMPAD8"; break;
    case 0x49:  KeyName = "NUMPAD9"; break;
    case 0x4B:  KeyName = "NUMPAD4"; break;
    case 0x4C:  KeyName = "NUMPAD5"; break;
    case 0x4D:  KeyName = "NUMPAD6"; break;
    case 0x4F:  KeyName = "NUMPAD1"; break;
    case 0x50:  KeyName = "NUMPAD2"; break;
    case 0x51:  KeyName = "NUMPAD3"; break;
    case 0x52:  KeyName = "NUMPAD0"; break;
    case 0x57:  KeyName = "F11"; break;
    case 0x58:  KeyName = "F12"; break;
    case 0x9D:  KeyName = "RCONTROL"; break;
    case 0xB8:  KeyName = "RALT"; break;
    case 0xC7:  KeyName = "HOME"; break;
    case 0xC8:  KeyName = "UP"; break;
    case 0xC9:  KeyName = "PAGEUP"; break;
    case 0xCB:  KeyName = "LEFT"; break;
    case 0xCD:  KeyName = "RIGHT"; break;
    case 0xCF:  KeyName = "END"; break;
    case 0xD0:  KeyName = "DOWN"; break;
    case 0xD1:  KeyName = "PAGEDOWN"; break;
    case 0xD2:  KeyName = "INSERT"; break;
    case 0xD3:  KeyName = "DELETE"; break;
    default: KeyName = IntToHex(Code, 2); break;
  }

  return KeyName;
}
//-----------------------------------------------------------------------------
void __fastcall TE7_DInput::Init()
{
  HRESULT dirval;

  AE7_DInput = this;

  dirval = DirectInputCreate((HINSTANCE)GetWindowLong(FHandle, GWL_HINSTANCE),
   DIRECTINPUT_VERSION, &FDirectInput, NULL);
  if(dirval != DI_OK) throw Exception("Can't create DI Object");

  dirval = FDirectInput->CreateDevice(GUID_SysKeyboard, &FKeyboard, NULL );
  if(dirval != DI_OK) throw Exception("Can't obtain Interface");

  dirval = FKeyboard->SetDataFormat( &c_dfDIKeyboard );
  if(dirval != DI_OK) throw Exception("Can't set data format");

  dirval = FKeyboard->SetCooperativeLevel(FHandle,
   DISCL_EXCLUSIVE | DISCL_FOREGROUND);

  if(dirval != DI_OK) throw Exception("Can't set cooperative level");

  if (FUseTimer)
   SetTimer(FHandle, Timer1, FTimerInterval, (FARPROC)Timer2Timer);

  FActive = true;
}
//-----------------------------------------------------------------------------
void __fastcall TE7_DInput::UpdateInputState()
{
  BYTE Buffer[256];                              //Key States
  HRESULT dirval;
  int Pos;

  if (!FActive) Init();                          //Not initialised
  if (!FActive) return;                          //Init Failed

  if(FKeyboard) {
     dirval = FKeyboard->GetDeviceState(sizeof(Buffer), &Buffer);
     if(dirval != DI_OK) {
       dirval = FKeyboard->Acquire();
       while(dirval == DIERR_INPUTLOST ||
             dirval == E_ACCESSDENIED) {
         dirval = FKeyboard->Acquire();
       }

       if(dirval != DI_OK) return;
     }

     for(Pos = 0; Pos < 256; Pos++) {
      if(Buffer[Pos] & 0x80) {
        if (FDIKeyDown) FDIKeyDown(this, Pos);
      }
    }
  }
}
//-----------------------------------------------------------------------------
void __fastcall TE7_DInput::UnBindAll()
{
  int Pos;
  for (Pos = 1; Pos < 256; Pos++) {
    strcpy(FKeyCom[Pos], " ");
  }
}
//---------------------------------------------------------------------------
namespace E7_dinput
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(TE7_DInput)};
        RegisterComponents("Engine7", classes, 0);
    }
}
//---------------------------------------------------------------------------
