//---------------------------------------------------------------------------
#ifndef E7_DInputH
#define E7_DInputH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <dinput.h>
#include <stdio.h>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
#define Timer1 (Byte)(1)

typedef void __fastcall (__closure *TDIKeyDown)(TObject* Sender,
 int KeyNum);
//---------------------------------------------------------------------------
class PACKAGE TE7_DInput : public TComponent
{
  private:
    bool FActive;
    HWND FHandle;
    TDIKeyDown FDIKeyDown;
    LPDIRECTINPUT FDirectInput;
    LPDIRECTINPUTDEVICE FKeyboard;
    bool FKeyStates[256];
    char FKeyCom[256][15];
    int FTimerInterval;
    bool FUseTimer;

protected:

public:
    __property bool Active = {read=FActive};

    __fastcall TE7_DInput(TComponent* Owner);
    __fastcall ~TE7_DInput(void);
    AnsiString __fastcall Bind(AnsiString KeyCode, AnsiString KeyCommand);
    void __fastcall EndInput();
    AnsiString __fastcall GetCommand(const int KeyNum);
    int __fastcall GetKeyCode(AnsiString KeyName);
    AnsiString __fastcall GetKeyName(int Code);
    void __fastcall Init();
    void __fastcall UpdateInputState();
    void __fastcall UnBindAll();

__published:
  __property TDIKeyDown DIKeyDown = {read=FDIKeyDown, write=FDIKeyDown};
  __property int TimerInterval = {read=FTimerInterval, write=FTimerInterval};
  __property bool UseTimer = {read=FUseTimer, write=FUseTimer};

};
//---------------------------------------------------------------------------
#endif
